#include <hmg.ch>

*------------------------------------------------------------------------------*
FUNCTION Main()
*------------------------------------------------------------------------------*
	PRIV lNew := .F.
	
	set(_SET_DELETED,.T.) 
	set(_SET_SOFTSEEK,.F.) 
	
	USE PRV alias PRV NEW 
	PACK
	INDEX ON LndID + PrvID TO PRVL01
	INDEX ON LndID + PrvNm TO PRVL02
	SET INDEX TO PRVL01, PRVL02
	
	IF ! IsWindowDefined( Win_PRV )
		Load Window Win_PRV
		Win_PRV.Center 
		Win_PRV.Activate
	ENDIF
RETURN

*------------------------------------------------------------------------------*
FUNCTION OnInit_Win_PRV()
*------------------------------------------------------------------------------*
	ON KEY ESCAPE OF Win_PRV ACTION ThisWindow.Release
	Load_Grid_PRV()
	Win_PRV.Grid_PRV.Refresh
	Win_PRV.Grid_PRV.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION Load_Grid_PRV()
*------------------------------------------------------------------------------*
	PRV->(DBSetorder('PRVL01'))
	PRV->(DBGotop())
	Win_PRV.Grid_PRV.DeleteAllItems
	DO WHILE .NOT. PRV->(EOF())
		Win_PRV.Grid_PRV.AddItem( {PRV->LndID, PRV->PrvID, PRV->PrvNm} )
		PRV->(DBSkip())
	ENDDO
	Win_PRV.Grid_PRV.Value := {1,1}
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_RefreshScreen()
*------------------------------------------------------------------------------*
	PRV_RefreshData()
	Win_PRV.Grid_PRV.Refresh
	Win_PRV.Grid_PRV.Setfocus
RETURN 

*------------------------------------------------------------------------------*
FUNCTION PRV_RefreshData()
*------------------------------------------------------------------------------*
	PRIV aRC := Win_PRV.Grid_PRV.Value
	
	msginfo( "Win_PRV.Grid_PRV.Value = " + str(aRC[1]) + ',' + str(aRC[2])  )
	
	IF Win_PRV.Grid_PRV.ItemCount == 0
		PRV_Button_Add()
	ELSE
		IF aRC[1] = 0 .or. aRC[1] > Win_PRV.Grid_PRV.ItemCount		
			PRV_NoAction()
		ELSE
			PRV_Edit()
		ENDIF
	ENDIF	
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Add()
*------------------------------------------------------------------------------*
	lNew := .T.
	
	Win_PRV.StatusBar.Item(1) := 'Record   ' + Ltrim( Str( Win_PRV.Grid_PRV.ItemCount + 1 ) )
	Win_PRV.StatusBar.Item(2) := 'Toevoegen record'

	Win_PRV.Text_PrvID.Value  := ""
	Win_PRV.Text_PrvNm.Value  := ""
	
	Win_PRV.Text_PrvID.Setfocus 
	Win_PRV.Text_PrvID.ReadOnly := .F.
	Win_PRV.Text_PrvNm.ReadOnly := .F.
	Win_PRV.PRV_Button_Delete.Enabled := .F.
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Edit()
*------------------------------------------------------------------------------*
	LOCAL aItem
	
	lNew := .F.
	
	aItem := Win_PRV.Grid_PRV.Item(aRC[1])
	
	Win_PRV.StatusBar.Item(1) := 'Record   ' + Ltrim( Str( aRC[1] ) ) + ;
									   ' / ' + Ltrim( Str( Win_PRV.Grid_PRV.ItemCount ) )  
	Win_PRV.StatusBar.Item(2) := 'Onderhoud record'
				
	Win_PRV.Text_PrvID.Value  := aItem[2]
	Win_PRV.Text_PrvNm.Value  := aItem[3]
	
	Win_PRV.Text_PrvID.ReadOnly := .T.
	Win_PRV.Text_PrvNm.ReadOnly := .F.
	Win_PRV.PRV_Button_Delete.Enabled := .T.
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_NoAction()
*------------------------------------------------------------------------------*
	lNew := .F.
	
	Win_PRV.StatusBar.Item(1) := ''
	Win_PRV.StatusBar.Item(2) := 'Onbepaalde actie'

	Win_PRV.Text_PrvID.Value  := ""
	Win_PRV.Text_PrvNm.Value  := ""
	
	Win_PRV.Text_PrvID.ReadOnly := .T.
	Win_PRV.Text_PrvNm.ReadOnly := .T.
	Win_PRV.PRV_Button_Delete.Enabled := .F.
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_OnEnter_Text_PrvID()
*------------------------------------------------------------------------------*
	Win_PRV.Text_PrvNm.Setfocus
RETURN

FUNCTION PRV_OnEnter_Text_PrvNm()
	PRV_Button_Save()
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Save()
*------------------------------------------------------------------------------*
	LOCAL cPrvID := Win_PRV.Text_PrvID.Value
	LOCAL aItem
	LOCAL aRC    := Win_PRV.Grid_PRV.Value
	
	IF lNew == .T.
		IF EMPTY(cPrvID) 
			MsgSTOP("Empty code" , "Controle")
			Win_PRV.Text_PrvID.Setfocus
			RETURN Nil
		ENDIF
		
		PRV->(DBSetorder('PRVL01'))
		IF PRV->(DBSeek( "BE " + cPrvID ))
			MsgSTOP("Code " + cPrvID + " already exists" , "Controle")
			Win_PRV.Text_PrvID.Setfocus
			RETURN Nil
		ENDIF
	ENDIF

	IF EMPTY( Win_PRV.Text_PrvNm.Value )
		MsgSTOP("Empty name" , "Controle")
		Win_PRV.Text_PrvNm.Setfocus
		RETURN Nil
	ENDIF

	IF lNew == .T.
		PRV->(DBAppend())
		PRV->(RLock())
		PRV->LndID := "BE "
		PRV->PrvID := Win_PRV.Text_PrvID.Value
		PRV_UpdDb()
		Win_PRV.Grid_PRV.AddItem( {PRV->LndID, PRV->PrvID, PRV->PrvNm} )
		Win_PRV.Grid_PRV.Value := { Win_PRV.Grid_PRV.ItemCount, 1 }
	ELSE
		aRC   := Win_PRV.Grid_PRV.Value
		aItem := Win_PRV.Grid_PRV.Item(aRC[1])
		
		IF PRV->(DBSeek( aItem[1] + aItem[2] ))
			PRV_UpdDb()
			Win_PRV.Grid_PRV.Item(aRC[1]) := {PRV->LndID, PRV->PrvID, PRV->PrvNm}
		ENDIF
	ENDIF
	
	PRV_RefreshData()
	Win_PRV.Grid_PRV.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_UpdDb()
*------------------------------------------------------------------------------*
	PRV->PrvNm := Win_PRV.Text_PrvNm.Value
	PRV->(DBUnlock())
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Delete()
*------------------------------------------------------------------------------*
	LOCAL aRC   := Win_PRV.Grid_PRV.Value
	LOCAL aItem := Win_PRV.Grid_PRV.Item(aRC[1])
	
	IF PRV->(DBSeek( aItem[1] + aItem[2] ))
		IF MsgOkCancel ("Delete " + aItem[2] + " " + ALLTRIM(aItem[3]), "Controle")
					
			PRV->(DBDelete())
			PRV->(DBUnlock())
			PRV->(DBSkip())
			IF PRV->(EOF())
				PRV->(DBGobottom())
			ENDIF
			
			Win_PRV.Grid_PRV.DeleteItem( aRC[1] )
			Win_PRV.Grid_PRV.Value := { aRC[1], aRC[2] }
			
			*IF aRC[1] > Win_PRV.Grid_PRV.ItemCount
			*	IF Win_PRV.Grid_PRV.ItemCount > 0
			*		aRC[1] := Win_PRV.Grid_PRV.ItemCount
			*	ENDIF
			*ENDIF
			
		ENDIF
	ENDIF
	
	PRV_RefreshData()
	Win_PRV.Grid_PRV.Setfocus
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Refresh()
*------------------------------------------------------------------------------*
	Load_Grid_PRV()
	PRV_RefreshScreen()
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Print()
*------------------------------------------------------------------------------*
	LOCAL lSuccess

	SELECT PRINTER DIALOG TO lSuccess PREVIEW

	If lSuccess == .T.
		PRV_PrintDoc()
	EndIf
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_PrintDoc
*------------------------------------------------------------------------------*
	LOCAL nRecno 
	
	LOCAL cItem2Prnt
	
	PRIV nVertMargin   := 20   // Vertical margin   
    PRIV nHorzMargin   := 20   // Horizontal margin 
	
    PRIV nFontSize     := 10   // In Pixels
	PRIV cFontName     := "Verdana"
	PRIV nCharLength   := 2.25
    PRIV nLineHeigth   := 5
	
	PRIV nMostRightCol := GetPrintableAreaWidth()- nHorzMargin
    PRIV nPageHeigth   := GetPrintableAreaHeight() - (nVertMargin * 2) - (5 * nLineHeigth)   // 1 Top Margin, 1 Bottom Margin, 5 Headerlines
	PRIV nLinesPerPag  := nPageHeigth / nLineHeigth    // Aantal lijnen voor detailafdruk
    PRIV nLinesPrinted 
	PRIV nPageNr       := 0
		
	PRIV nPrintRow 
	PRIV nPrintCol 
	
	START PRINTDOC 
		START PRINTPAGE	
			nRecno := PRV->(recno())
			
			PRV->(DBSetorder( "PRVL01" ))
			PRV->(DBGotop())			
			PRV_PrintPageHeader()
			DO WHILE ! PRV->(EOF())
				nPrintCol := nHorzMargin			
							
				cItem2Prnt := PRV->LndID
                @ nPrintRow, nPrintCol PRINT cItem2Prnt FONT cFontName SIZE nFontSize  
				nPrintCol += nCharLength * LEN( cItem2Prnt )

				cItem2Prnt := PRV->PrvID
                @ nPrintRow, nPrintCol PRINT cItem2Prnt FONT cFontName SIZE nFontSize  
				nPrintCol += nCharLength * LEN( cItem2Prnt )	
				
				cItem2Prnt := PRV->PrvNm
				nPrintCol += nCharLength 
				@ nPrintRow, nPrintCol PRINT cItem2Prnt FONT cFontName SIZE nFontSize 
					
				IF ++nLinesPrinted > nLinesPerPag
					PRV_PrintPageFooter()
					END PRINTPAGE 
					START PRINTPAGE 
					PRV_PrintPageHeader()					
				ELSE
					nPrintRow += nLineHeigth
				ENDIF  						
			
				PRV->(DBSkip())
			ENDDO
			nPrintRow -= nLineHeigth
			PRV_PrintPageFooter()
			
			PRV->(DBGoto(nRecno))
		END PRINTPAGE
	END PRINTDOC
	
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_PrintPageHeader()
*------------------------------------------------------------------------------*
	LOCAL cItem2Prnt, nColumnLen
	
	nPageNr++
	
	nLinesPrinted := 0
	nPrintRow := nVertMargin
	nPrintCol := nHorzMargin 
	
	@ nPrintRow, 105 PRINT "List provinces" CENTER FONT cFontName SIZE nFontSize BOLD ITALIC
	nPrintRow += nLineHeigth
	@ nPrintRow, nPrintCol PRINT DATE() FONT cFontName SIZE nFontSize
    @ nPrintRow, nMostRightCol PRINT "P. " + NTOC( nPageNr ) RIGHT FONT cFontName SIZE nFontSize
	nPrintRow += nLineHeigth * 2
   
    cItem2Prnt := PRV->LndID   
    nColumnLen := nCharLength * LEN( cItem2Prnt ) - 1
	@ nPrintRow, nPrintCol + ( nColumnLen / 2 ) PRINT "Ctry" CENTER BOLD
    @ nPrintRow + nLineHeigth, nPrintCol PRINT LINE TO ;
	  nPrintRow + nLineHeigth, nPrintCol + nColumnLen PENWIDTH .01   
	nPrintCol += nColumnLen + nCharLength
   
    cItem2Prnt := PRV->PrvID   
    nColumnLen := nCharLength * LEN( cItem2Prnt ) - 1
	@ nPrintRow, nPrintCol + ( nColumnLen / 2 ) PRINT "Prov" CENTER BOLD
    @ nPrintRow + nLineHeigth, nPrintCol PRINT LINE TO ;
	  nPrintRow + nLineHeigth, nPrintCol + nColumnLen PENWIDTH .01   
	nPrintCol += nColumnLen + nCharLength
	
    cItem2Prnt := PRV->PrvNm 
	nColumnLen := nCharLength * LEN( cItem2Prnt ) - 1   
    @ nPrintRow, nPrintCol + ( nColumnLen / 2 ) PRINT "Naam" CENTER BOLD
    @ nPrintRow + nLineHeigth, nPrintCol PRINT LINE TO ;
	  nPrintRow + nLineHeigth, nPrintCol + nColumnLen PENWIDTH .01                                 
       	
    nPrintRow += nLineHeigth * 1.5 
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_PrintPageFooter()
*------------------------------------------------------------------------------*
RETURN 

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Close()
*------------------------------------------------------------------------------*
	ThisWindow.Release
RETURN



